<template>
  <el-dialog v-model="props.modelValue" title="编辑海报" width="900px" @closed="closeDialog" @open="openDialog">
    <el-form ref="formRef" :model="formData" :rules="rules">
      <el-row>
        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="语言类型" prop="i18n_lang_type">
            <el-select v-model="formData.i18n_lang_type_guid" clearable placeholder="请选择">
              <el-option v-for="item in i18n_lang_type" :key="item.i18n_lang_type_guid"
                :label="item.i18n_lang_type_code" :value="item.i18n_lang_type_guid"></el-option>
            </el-select>
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item :label-width='labelWidth' label="位置" prop="poster_location">
            <el-select disabled v-model="formData.poster_location" clearable placeholder="请选择">
              <el-option v-for="item in poster_location" :key="item.dictionary_guid" :label="item.dictionary_name"
                :value="item.dictionary_value"></el-option>
            </el-select>
          </el-form-item>
        </el-col>
        <el-col :span='24'>
          <el-form-item :label-width='labelWidth' label='图片' prop='poster_img'>
            <UploadImage ref='uploadRef' v-model='formData.poster_img' :data=uoloadData :limit='1' :fileSize='20'
              :drag='true' :isShowTip='true' />
          </el-form-item>
        </el-col>

        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="标题" prop="poster_title">
            <el-input v-model='formData.poster_title' type="text" placeholder='请输入标题'></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="描述" prop="poster_describe">
            <el-input v-model='formData.poster_describe' type="text" placeholder='请输入描述'></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label-width="labelWidth" label="排序" prop="poster_sort">
            <el-input-number v-model='formData.poster_sort' controls-position='right' :min="1"></el-input-number>
          </el-form-item>
        </el-col>

      </el-row>
    </el-form>
    <template #footer>
      <span class="dialog-footer">
        <el-button type="primary" @click="handleEditClick(formRef)">保存</el-button>
        <el-button @click="handleResetClick(formRef)">重置</el-button>
        <el-button @click="closeDialog()">取消</el-button>
      </span>
    </template>
  </el-dialog>
</template>

<script setup>
import { reactive, ref, watch } from "vue";
import { editPoster, getDictionary } from "~/service/poster";
import { useLoginStore } from "~/store";
import { getI18nLangTypeList } from '~/service/i18n_lang_type';
// --业务参数



// --业务方法

// 字典获取
const poster_location = ref([]);
async function get_poster_location() {
  await getDictionary({ dictionary_value: 'poster_location' }).then((res) => {
    poster_location.value = res
  })
}



// 语言类型code
const i18n_lang_type = ref();
async function geti18n_lang_typeList() {
  getI18nLangTypeList({ limit: 9999 }).then((res) => {
    if (res.code == 0) {
      i18n_lang_type.value = res.data
    }
  })
}
// --基础参数
const store = useLoginStore();
const headers = {
  Accept: "application/json",
  ...store.headers,
};
const formRef = ref();
const labelWidth = 100;
const props = defineProps({
  modelValue: Boolean,
  data: Object,
  done: Function,
});
const emits = defineEmits(["update:modelValue"]);
const formData = ref({
  ...props.data,
});
const uoloadData = ref({
  dirName: "Poster"
})


// --基础方法
watch(props, (v) => {
  formData.value = v.data;


});

// 打开弹窗时执行
const openDialog = () => {
  get_poster_location()
  geti18n_lang_typeList()
};

const closeDialog = () => {
  props.done();
  emits("update:modelValue", false);
};

const rules = reactive({
  poster_location: [
    {
      required: true,
      message: '位置不能为空'
    }
  ],
  poster_img: [
    {
      required: true,
      message: '图片不能为空'
    }
  ],
  poster_sort: [
    {
      required: true,
      message: '排序不能为空'
    }
  ],

});

const handleEditClick = async (formEl) => {
  console.log(formData.value);
  if (!formEl) return;
  formEl.validate(async (valid) => {
    if (!valid) {
      return;
    }

    const { code } = await editPoster(formData.value);
    if (code == 0) {
      closeDialog();
      props.done();
    }
  });
};
const handleResetClick = async (formEl) => {
  if (!formEl) return;
  formEl.resetFields();
};
</script>

<style lang="less" scoped></style>
